Package: PBSddesolve
Version: 1.13.7
Date: 2025-11-12
Title: Solver for Delay Differential Equations
Authors@R: c(
   person("Alex", "Couture-Beil", role = "aut", email = "alex@mofo.ca"),
   person(c("Jon", "T."), "Schnute", role = "aut", email = "schnutej@shaw.ca"),
   person("Rowan", "Haigh", role = c("aut"), email = "rowan.haigh@dfo-mpo.gc.ca"),
   person(c("Simon", "N."), "Wood", role = "aut", email = "s.wood@bath.ac.uk"),
   person(c("Benjamin", "J."), "Cairns", role = "aut"),
   person("Nicholas", "Boers", role = "ctb", email = "nboers@gmail.com"),
   person("Nick", "Fisch", role = "cre", email = "nick.fisch@dfo-mpo.gc.ca"))
Author: Alex Couture-Beil [aut],
  Jon T. Schnute [aut],
  Rowan Haigh [aut],
  Simon N. Wood [aut],
  Benjamin J. Cairns [aut],
  Nicholas Boers [ctb],
  Nick Fisch [cre]
Maintainer: Nick Fisch <nick.fisch@dfo-mpo.gc.ca>
Copyright: 2007-2025, Fisheries and Oceans Canada
Depends: R (>= 4.2.0)
Suggests: PBSmodelling
NeedsCompilation: yes
Description: Functions for solving systems of delay differential equations by
   interfacing with numerical routines written by Simon N. Wood, including
   contributions from Benjamin J. Cairns. These numerical routines first
   appeared in Simon Wood's 'solv95' program. This package includes a vignette
   and a complete user's guide. 'PBSddesolve' originally appeared on CRAN under
   the name 'ddesolve'. That version is no longer supported. The current name
   emphasizes a close association with other 'PBS' packages, particularly
   'PBSmodelling'.
License: GPL (>= 2)
URL: https://github.com/pbs-software/pbs-ddesolve
Packaged: 2025-11-13 18:16:20 UTC; FISCHN
Repository: CRAN
Date/Publication: 2025-11-14 12:50:17 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-25 18:08:52 UTC; unix
Archs: PBSddesolve.so.dSYM

test.simple <- function()
{
	#simple horizontal line
	grad <- function( t, y )
	{
		return( 0 );
	}
	
	#test an int
	yinit <- 1
	out <- dde( y=yinit, func=grad, times=seq( 0, 1,length=100 ), hbsize=0)
#browser();return()
	checkTrue( all( out$y1 == yinit ) )  ## weird: often 1==1 is FALSE ???
	
	#test a float
	yinit <- 10.5
	out <- dde( y=yinit, func=grad, times=seq( 0, 1,length=100 ), hbsize=0)
	checkTrue( all( out$y1 == yinit ) )

	#test negative float
	yinit <- -10.5
	out <- dde( y=yinit, func=grad, times=seq( 0, 1,length=100 ), hbsize=0)
	checkTrue( all( out$y1 == yinit ) )

}

#check yinit names are properly passed to grad function
test.y_init_names <- function()
{
	grad <- function( t, y )
	{
		checkTrue( all( n == names( y ) ) )
		return( c(0, 1) );
	}
	
	yinit <- c( y1 = 1, y2 = 2 )
	n <- names( yinit )
	out <- dde( y=yinit, func=grad, times=seq( 0, 1,length=100 ), hbsize=0)
}

require(PBSddesolve)
if (!require(PBSmodelling)) stop("The package PBSmodelling must be installed for this demo")

local(env=.PBSddeEnv, expr={

#close any existing windows
closeWin("window")

#store working directory
if (!exists("oldwd") || getwd() != system.file(package = "PBSddesolve")) {
	oldwd <- getwd()
	setwd(system.file(package = "PBSddesolve"))
}

# modified by RH (2014-05-14)
#  changed x$t to x$time to eliminate partial matching warnings.
runPlot <- function()
{
	getWinVal(scope="L")
	if (A0 <=0) A0 = GT0(0) # RH: Don't allow user to specify A0<=0 (avoids crash)
	
	myGrad <- function(t, y) {
		if (t-t0 >= tau) ylag <- pastvalue(t-tau)
		else ylag <- 0
		yexp <- exp(-theta*ylag[1]/A0)
		yp <- P*ylag[1]*yexp-delta*y[1]
		return( list(yp, c(dy=yp, yexp=yexp)) ) }
	
	#solve the ODE from t0..t1
	x <- dde(y=A0, func=myGrad, times=seq(t0,t1), hbsize=1000) 
	
	if (ptype=="t") {
		frame(); resetGraph();
		expandGraph(mfrow=c(3,1),mar=c(4,4,2,1),mgp=c(2.75,.75,0),cex.main=1.5,cex.lab=1.5)
		plot(x=x$time, y=x$y1, type="l", main="Adult Blowfly Population", xlab="Time", ylab="Population (y)")
		plot(x=x$time, y=x$dy, type="l", main="Rate of Change of Adult Population", xlab="Time", ylab="delta Population (dy)")
		plot(x=x$time, y=x$yexp, type="l", main="exp(-theta*ylag[1] / A0)", xlab="Time", ylab="exp value")
	}
	else if (ptype=="p") {
		frame(); resetGraph();
		plot(x, main="Adult Blowfly Population") }
}

#restore working directory once demo is done
#onClose <- function() { setwd(oldwd); }
# Now handled by `.onClosePBSddeExamples`

createWin("demo_files/blowflies_win.txt")
})

# Newton's Law of Cooling
# Models the cooling of a cup of coffee left in a room (ACB)
# see http://en.wikipedia.org/wiki/Heat_conduction#Newton.27s_law_of_cooling
require(PBSddesolve)
if (!require(PBSmodelling)) stop("The package PBSmodelling must be installed for this demo")

local(env=.PBSddeEnv, expr={

closeWin("window")

#store working directory
if (!exists("oldwd") || getwd() != system.file(package = "PBSddesolve")) {
	oldwd <- getwd()
	setwd(system.file(package = "PBSddesolve"))
}

runPlot <- function() {
	#extract variables from window
	getWinVal(scope="L")
	
	# `y' is the estimated value of the variable at time `t'
	# y[1] represents the temperature of a cup of coffee at a given time `t'.
	# dy/dt ~ y - room tempurature. 
	# so we can write dy/dt = -rho(y - roomTemp)
	myGrad <- function(t, y) {
		y1 <- -rho*(y[1]-Tenv)
		return(y1) 
	}
	#solve the ODE from t0..t1 - (ignore hbsize, setting to zero may crash)
	x <- dde(y=Tcup, func=myGrad, times=seq(t0,t1,length=100), hbsize=0) 
	frame(); resetGraph();
	plot(x, type="l", main="Cooling of a cup of coffee", ylab="Tempurature", xlab="Time")
}

#restore working directory once demo is done
#onClose <- function() { setwd(oldwd); }
# Now handled by `.onClosePBSddeExamples`

createWin("demo_files/cooling_win.txt")
})

#Source this file to run all tests

require( "PBSddesolve" )
require( "RUnit" )

testsuite.dde <- defineTestSuite("dde",
	dirs = file.path(path.package(package="PBSddesolve"), "unitTests"),
	testFileRegexp = "^runit.+\\.r",
	testFuncRegexp = "^test.+",
	rngKind = "Marsaglia-Multicarry",
	rngNormalKind = "Kinderman-Ramage")


testResult <- runTestSuite(testsuite.dde)
printTextProtocol(testResult)

require(PBSddesolve)
if (!require(PBSmodelling)) stop("The package PBSmodelling must be installed for this demo")

local(env=.PBSddeEnv, expr={

#close any existing windows
closeWin("window")

#store working directory
if (!exists("oldwd") || getwd() != system.file(package = "PBSddesolve")) {
	oldwd <- getwd()
	setwd(system.file(package = "PBSddesolve"))
}

runPlot <- function()
{
	#extract variables from GUI
	getWinVal(scope="L")
	
	#function to calculate gradient at a given time
	myGrad <- function(t, y, parms=NULL) {
		y1 <- sigma*(y[2]-y[1]) 
		y2 <- y[1]*(tau-y[3]) - y[2]
		y3 <- y[1]*y[2] - rho*y[3]
		if (derivative=="yes") {
			deriv <- c(dy1=y1,dy2=y2,dy3=y3) #R will merge previous name found in y
			names( deriv ) <- c( "dy1", "dy2", "dy3" ) #so they must be reset here (LAME)
			return(list(c(y1,y2,y3), deriv))
		}
		else
			return(list(c(y1,y2,y3), NULL))
	}
	#initial values
	yinit <- c(y1=y1,y2=y2,y3=y3)
	#solve ODE
	#if (solver=="PBSddesolve") {
		x <- dde(y=yinit, func=myGrad, times=seq(t0,t1,timestep), hbsize=0)
	#}
	#else if (solver=="deSolve") {
	#	require(deSolve) || stop("deSolve is required")
	#	x <- lsoda(y=yinit, times=seq(from=t0, to=t1, by=timestep), func=myGrad, parms=NULL, rtol=1e-6, atol=1e-4)
	#	x <- as.data.frame(x)
	#	if (derivative=="yes") #something weird happens to the labels with odesolve
	#		colnames(x)<-c("time", "y1", "y2", "y3", "dy1", "dy2", "dy3")
	#}
	frame(); resetGraph();
	pairs(x, pch=15, gap=0, cex=0.2) # pch=183 does not work on UNIX, pch="." is too small
}

#function to restore working directory once demo is done
#onClose <- function() { setwd(oldwd); }
# Now handled by `.onClosePBSddeExamples`

createWin("demo_files/lorenz_win.txt")

})

require(PBSddesolve)
if (!require(PBSmodelling)) stop("The package PBSmodelling must be installed for this demo")

local(env=.PBSddeEnv, expr={

#close any existing windows
closeWin("window")

#store working directory
if (!exists("oldwd") || getwd() != system.file(package = "PBSddesolve")) {
	oldwd <- getwd()
	setwd(system.file(package = "PBSddesolve")) }

# Sine waves used for swithing
sinWave <- function(t,aa,pp) { sin(2*pi*(aa + (t/pp)) ) }

# the switch function
mySwitch <- function(t,y,parms) {
	a <- parms$a; p <- parms$p;
	c( sinWave(t,a[1],p[1]), sinWave(t,a[2],p[2]) ) }

# the map function
myMap <- function(t,y,swID,parms) {
	Y <- parms$Y; f <- parms$f;
	if (swID==1) y <- y + Y else y <- (1-f)*y }
myMapCollect <- function(t,y,swID,parms) {
	Y <- parms$Y; f <- parms$f;
	swTimes = .PBSddeEnv$swTimes
	swTimes[[swID]] <- c( swTimes[[swID]], t ) #collect switch times
	assign("swTimes", swTimes, envir=.PBSddeEnv)
	if (swID==1) y <- y + Y else y <- (1-f)*y }

# the gradient function
myGrad <- function(t,y,parms) {
	-parms$r*y }

# modified by RH (2014-05-14)
#  changed yout1$t to yout1$time, yout2$t to yout2$time, to eliminate partial matching warnings.
icePlot <- function() {
	assign("swTimes", list(c(), c()),envir=.PBSddeEnv)   # store times when map is called
	getWinVal(scope="L");

	# calculate actual time offset for deliveries
	if (rgive) agive <- runif(1,min=0.0001,max=max(0.0001,ogive)) else agive <- ogive
	if (rtake) atake <- runif(1,min=0.0001,max=max(0.0001,otake)) else atake <- otake
	setWinVal(list(agive=round(agive,2),atake=round(atake,2)));
	
	a <- c(agive,atake); p <- c(tgive,ttake); 
	gelati <- list(a=a,p=p,r=r,Y=Y,f=f);
	
	tt1 <- seq(from,to,by); tt2 <- seq(from,to,see);
	# solve the dde system
	yout1 <- dde(y=y0, times=tt1, func=myGrad, switchfunc=mySwitch, mapfunc=myMapCollect, parms=gelati)
	yout2 <- dde(y=y0, times=tt2, func=myGrad, switchfunc=mySwitch, mapfunc=myMap, parms=gelati)
	xadd <- swTimes[[1]][-1]; yadd <- sinWave(xadd,a[1],p[1]);
	xsub <- swTimes[[2]][-1]; ysub <- sinWave(xsub,a[2],p[2]);
	zadd <- is.element(yout1$time,xadd); zsub <- is.element(yout1$time,xsub);

	#plot results
	frame(); resetGraph();
	expandGraph(mfrow=c(2,1),mar=c(3,3,2,1),mgp=c(1.75,.5,0));
	plot( yout1$time, yout1$ice, type="l", lwd=2, xlab="days", ylab="ice cream", 
		main="DDE with two switches", col="cornflowerblue" );
	points(yout2$time,yout2$ice,col="blue",cex=1.5,pch=16);
	points(yout1$time[zadd], yout1$ice[zadd], col="green3",cex=1.5,pch=16)
	points(yout1$time[zsub], yout1$ice[zsub], col="red",cex=1.5,pch=16)

	#display switch functions (only for demo illustration)
	plot(tt1,sinWave(tt1,a[1],p[1]), type="l", col="green3", 
		main="Switch function and corresponding map function call",
		xlab="days", ylab="y")
	lines(tt1,sinWave(tt1,a[2],p[2]), type="l", col="red" )
	points(xadd, yadd, col="green3",cex=1.5,pch=16)
	points(xsub, ysub, col="red",cex=1.5,pch=16)
}
#restore working directory once demo is done
#onClose <- function() { setwd(oldwd); }
# Now handled by `.onClosePBSddeExamples`

createWin("demo_files/icecream_win.txt")
})
